//	A1.3.- timers
//	Autores: Jess Mara Corres, Carlos Ruiz Zamarreo y Cndido Bariin
//	Pamplona, Agosto 2016

// CONSTANTES, MACROS Y FUNCIONES PARA EL TIMER 0

#define RTCC_INTERNAL 		0x00
#define RTCC_EXT_RISE		0x20
#define RTCC_EXT_FALL		0x30
#define RTCC_DIV1	 		0x0F
#define RTCC_DIV2			0x00
#define RTCC_DIV4			0x01
#define RTCC_DIV8			0x02
#define RTCC_DIV16			0x03
#define RTCC_DIV32			0x04
#define RTCC_DIV64			0x05
#define RTCC_DIV128			0x06
#define RTCC_DIV256			0x07

#define setup_timer0(value) OPTION_REG=((OPTION_REG&0xC0)|value)
#define set_timer0(value) 	TMR0=value
#define get_timer0()			TMR0

// CONSTANTES, MACROS Y FUNCIONES PARA EL WATCHDOG

#define WDT_18MS 			0x08
#define WDT_36MS 			0x09
#define WDT_72MS 			0x0A
#define WDT_144MS 			0x0B
#define WDT_288MS 			0x0C
#define WDT_576MS 			0x0D
#define WDT_1152MS 			0x0E
#define WDT_2304MS 			0x0F

#define setup_wdt(value) 	OPTION_REG=(OPTION_REG&0xF0)|value
#define restart_wdt()		CLRWDT()

// CONSTANTES, MACROS Y FUNCIONES PARA EL TIMER 1

#define T1_DISABLED	 		0x00
#define T1_OFF			0x00
#define T1_ON			0x01
#define T1_INT			0x00
#define T1_EXT			0x02
#define T1_DIV1			0x00
#define T1_DIV2			0x10
#define T1_DIV4			0x20
#define T1_DIV8			0x30
#define T1_OSC_EN			0x08

#define setup_timer1(value) T1CON=value
#define set_timer1(value) 	TMR1=value
#define get_timer1()			TMR1
#define start_timer1()		T1CON|=0x01
#define stop_timer1()		T1CON&=0xFE

// CONSTANTES, MACROS Y FUNCIONES PARA EL TIMER 2

#define T2_DISABLED	 		0x00
#define T2_OFF			0x00
#define T2_ON			0x04
#define T2_POST_DIV1			0x00
#define T2_POST_DIV2			0x08
#define T2_POST_DIV3			0x10
#define T2_POST_DIV4			0x18
#define T2_POST_DIV5			0x20
#define T2_POST_DIV6			0x28
#define T2_POST_DIV7			0x30
#define T2_POST_DIV8			0x38
#define T2_POST_DIV9			0x40
#define T2_POST_DIV10		0x48
#define T2_POST_DIV11		0x50
#define T2_POST_DIV12		0x58
#define T2_POST_DIV13		0x60
#define T2_POST_DIV14		0x68
#define T2_POST_DIV15		0x70
#define T2_POST_DIV16		0x78
#define T2_PRED_DIV1			0x00
#define T2_PRED_DIV4			0x01
#define T2_PRED_DIV16		0x02
#define T2_PRED_DIV64		0x03

#define setup_timer2(value) T2CON=value
#define set_timer2(value) 	PR2=value; \
					TMR2=0
#define get_timer2()			TMR2
#define start_timer2()		T2CON|=0x04
#define stop_timer2()		T2CON&=0xFB