#include <htc.h>
#include "i2c.h"

// Gets a byte from the I2C slave ADDRESS=dat and REG=reg

unsigned char	EEPROM_i2c_readbyte(unsigned char add, unsigned int reg){
	unsigned char temp=0;
	i2c_start();
	if(i2c_write(add+WRITE)==0){
		return 0;
	}
	if(i2c_write((unsigned char)(reg>>8))==0){
	return 0;
	}
	if(i2c_write((unsigned char)(reg))==0){
	return 0;
	}
	i2c_restart();
	if(i2c_write(add+READ)==0){
	return 0;
	}
	temp=i2c_read();
	i2c_sendnack();
	i2c_stop();
	return temp;	
}

// Writes a byte=dato from the I2C slave ADDRESS=dat at REG=reg

unsigned char EEPROM_i2c_writebyte(unsigned char add, unsigned int reg, unsigned char dato){
	i2c_start();
	if(i2c_write(add+WRITE)==0){
		return 0;
	}
	if(i2c_write((unsigned char)(reg>>8))==0){
	return 0;
	}
	if(i2c_write((unsigned char)(reg))==0){
	return 0;
	}
	if(i2c_write(dato)==0){
	return 0;
	}
	i2c_stop();
	return 1;
}